#include <LPC17xx.h>
#include "ILI9325.h"
#include "Font8x16.h"
#include "Font16x32.h"
#include "delay.h"

void ILI9325_WR_Index(unsigned char Index)
{
   RS_L;
   WR_L;
   ILI9325_Data_Port_Set=Index;
   ILI9325_Data_Port_Clr=(Index^0xFFFF);
   WR_H;
}
void ILI9325_WR_Data (unsigned int Data)
{
   RS_H;
   WR_L;
   ILI9325_Data_Port_Set=Data;
   ILI9325_Data_Port_Clr=(Data^0xFFFF);
   WR_H;
}
void ILI9325_Init(void)
{
   ILI9325_Data_Dir_Out;
   ILI9325_Control_Dir_Out;
   RST_H;
   delay_ms(100);
   RST_L;
   delay_ms(100);
   RST_H;
  //************* Start Initial Sequence **********//
	ILI9325_WR_Data_Index(0xE3, 0x3008); // Set internal timing
	ILI9325_WR_Data_Index(0xE7, 0x0012); // Set internal timing
	ILI9325_WR_Data_Index(0xEF, 0x1231); // Set internal timing

  ILI9325_WR_Data_Index(0x00, 0x0001); // Set internal timing
	ILI9325_WR_Data_Index(0x01, 0x0100); // Start internal OSC
	ILI9325_WR_Data_Index(0x02, 0x0700); // set 1 line inversion
	ILI9325_WR_Data_Index(0x03, 0x0090); // set GRAM write direction and BGR=1.
	ILI9325_WR_Data_Index(0x04, 0x0000); // Resize register
	ILI9325_WR_Data_Index(0x07, 0x0133);
	ILI9325_WR_Data_Index(0x08, 0x0202); // set the back porch and front porch
	ILI9325_WR_Data_Index(0x09, 0x000F); // set non-display area refresh cycle ISC[3:0]
	ILI9325_WR_Data_Index(0x0A, 0x0000); // FMARK function
	ILI9325_WR_Data_Index(0x0C, 0x0000); // RGB interface setting
	ILI9325_WR_Data_Index(0x0D, 0x0000); // Frame marker Position
	ILI9325_WR_Data_Index(0x0F, 0x0000); // RGB interface polarity
	//*************Power On sequence ****************//
	ILI9325_WR_Data_Index(0x10, 0x0000); // SAP, BT[3:0], AP, DSTB, SLP, STB
	ILI9325_WR_Data_Index(0x11, 0x0000); // DC1[2:0], DC0[2:0], VC[2:0]
	ILI9325_WR_Data_Index(0x12, 0x0000); // VREG1OUT voltage
	ILI9325_WR_Data_Index(0x13, 0x0000); // VDV[4:0] for VCOM amplitude
	delay_ms(400);
	ILI9325_WR_Data_Index(0x10, 0x17A0);
	ILI9325_WR_Data_Index(0x11, 0x0007);
	delay_ms(500); // Delay 50ms
	ILI9325_WR_Data_Index(0x12, 0x0018);
	delay_ms(500); // Delay 50ms
	ILI9325_WR_Data_Index(0x13, 0x1000);

	ILI9325_WR_Data_Index(0x29, 0x000B); // Set VCM[5:0] for VCOMH
	ILI9325_WR_Data_Index(0x2B, 0x000D); // Set Frame Rate
	delay_ms(500); // Delay 50ms
	ILI9325_WR_Data_Index(0x20, 0x0000); // GRAM horizontal Address
	ILI9325_WR_Data_Index(0x21, 0x0000); // GRAM Vertical Address
	// ----------- Adjust the Gamma Curve ----------//
	ILI9325_WR_Data_Index(0x30, 0x0101);
	ILI9325_WR_Data_Index(0x31, 0x0101);
	ILI9325_WR_Data_Index(0x32, 0x0101);
	ILI9325_WR_Data_Index(0x35, 0x0101);
	ILI9325_WR_Data_Index(0x36, 0x0201);
	ILI9325_WR_Data_Index(0x37, 0x0707);
	ILI9325_WR_Data_Index(0x38, 0x0707);
	ILI9325_WR_Data_Index(0x39, 0x0707);
	ILI9325_WR_Data_Index(0x3C, 0x0101);
	ILI9325_WR_Data_Index(0x3D, 0x0201);
	//------------------ Set GRAM area ---------------//
	ILI9325_WR_Data_Index(0x50, 0x0000); // Horizontal GRAM Start Address
	ILI9325_WR_Data_Index(0x51, 0x00EF); // Horizontal GRAM End Address
	ILI9325_WR_Data_Index(0x52, 0x0000); // Vertical GRAM Start Address
	ILI9325_WR_Data_Index(0x53, 0x013F); // Vertical GRAM End Address
	ILI9325_WR_Data_Index(0x60, 0x2700); // Gate Scan Line
	ILI9325_WR_Data_Index(0x61, 0x0001); // NDL,VLE, REV
	ILI9325_WR_Data_Index(0x6A, 0x0000); // set scrolling line
	//-------------- Partial Display Control ---------//
	ILI9325_WR_Data_Index(0x80, 0x0000);
	ILI9325_WR_Data_Index(0x81, 0x0000);
	ILI9325_WR_Data_Index(0x82, 0x0000);
	ILI9325_WR_Data_Index(0x83, 0x0000);
	ILI9325_WR_Data_Index(0x84, 0x0000);
	ILI9325_WR_Data_Index(0x85, 0x0000);
	//-------------- Panel Control -------------------//
	ILI9325_WR_Data_Index(0x90, 0x0010);
	ILI9325_WR_Data_Index(0x92, 0x0000);
	ILI9325_WR_Data_Index(0x95, 0x0110);
}
void ILI9325_WR_Data_Index(unsigned char Index,unsigned int Data)
{
   ILI9325_WR_Index(Index);
   ILI9325_WR_Data(Data);
   /*RS_L;
   ILI9325_Data_Port_Set=Index;
   ILI9325_Data_Port_Clr=(Index^0xFFFF);
   WR_L;
   WR_H;
   RS_H;
   ILI9325_Data_Port_Set=Data;
   ILI9325_Data_Port_Clr=(Data^0xFFFF);
   WR_L;
   WR_H;*/
}
void ILI9325_Clear(unsigned int Color) 
{
   unsigned long int i;
   ILI9325_WR_Data_Index(0x50, 0x0000); 
   ILI9325_WR_Data_Index(0x51, 0x00EF); 
   ILI9325_WR_Data_Index(0x52, 0x0000); 
   ILI9325_WR_Data_Index(0x53, 0x013F); 
   ILI9325_WR_Data_Index(0x20, 0x0000); 
   ILI9325_WR_Data_Index(0x21, 0x0000); 
   ILI9325_WR_Index(0x22);
   for(i=0;i<76800;i++)
   {
	  ILI9325_WR_Data(Color);
   }

}
void ILI9325_Set_X_Y(unsigned int X,unsigned int Y)
{
   ILI9325_WR_Data_Index(0x20, X); 
   ILI9325_WR_Data_Index(0x21, Y);
}
void ILI9325_Set_Area(unsigned int X0,unsigned int Y0,unsigned int X1,unsigned int Y1)
{
   ILI9325_WR_Data_Index(0x50, X0); 
   ILI9325_WR_Data_Index(0x51, X1); 
   ILI9325_WR_Data_Index(0x52, Y0); 
   ILI9325_WR_Data_Index(0x53, Y1); 
   ILI9325_WR_Data_Index(0x20, X0); 
   ILI9325_WR_Data_Index(0x21, Y0);
}
void ILI9325_WR_Char(unsigned int X,unsigned int Y, char Data,unsigned int Back_Color,unsigned int Fore_Color)
{
   char i,j;
   ILI9325_Set_Area(X,Y,X+7,Y+15);
   ILI9325_Set_X_Y(X,Y);
   ILI9325_WR_Index(0x22);
   for(j=0;j<16;j++)
   {
     for(i=0;i<8;i++)
     {
	    if(((Font8x16[Data-32][j]>>i)& 0x01))
	    {
		    ILI9325_WR_Data(Fore_Color);
	    }
	    if(!((Font8x16[Data-32][j]>>i)& 0x01))
	    {
		    ILI9325_WR_Data(Back_Color);
	    }
     }
   }
}
void ILI9325_WR_String(unsigned int X,unsigned int Y,char *String,unsigned int Back_Color,unsigned int Fore_Color)
{
   int i=0;
   while(*String)
   {
	   ILI9325_WR_Char(X+i,Y,*String,Back_Color,Fore_Color);
	   i+=8;
	   String++;
   }
}
void ILI9325_WR_Char16_32(unsigned int X,unsigned int Y, char Data,unsigned int Back_Color,unsigned int Fore_Color)
{
   char i,j;
	 unsigned short TData;
   ILI9325_Set_Area(X,Y,X+15,Y+31);
   ILI9325_Set_X_Y(X,Y);
   ILI9325_WR_Index(0x22);
   for(j=0;j<64;j+=2)
   {
     TData=Font16x32[Data-32][j]; 
		 TData=TData<<8;
		 TData|=Font16x32[Data-32][j-1]; 
		 for(i=16;i>0;i--)
     {
	    if(((TData>>i)& 0x01))
	    {
		    ILI9325_WR_Data(Fore_Color);
	    }
	    if(!((TData>>i)& 0x01))
	    {
		    ILI9325_WR_Data(Back_Color);
	    }
     }
   }
}
void ILI9325_WR_String16_32(unsigned int X,unsigned int Y,char *String,unsigned int Back_Color,unsigned int Fore_Color)
{
   int i=0;
   while(*String)
   {
	   ILI9325_WR_Char16_32(X+i,Y,*String,Back_Color,Fore_Color);
	   i+=16;
	   String++;
   }
}
void Draw_H_Line(unsigned int X0,unsigned int Y0,unsigned int W,unsigned int Color)
{
   int i=0;
	 ILI9325_WR_Data_Index(0x50, X0); 
   ILI9325_WR_Data_Index(0x51,X0+W); 
   ILI9325_WR_Data_Index(0x52, Y0); 
   ILI9325_WR_Data_Index(0x53,Y0); 
   ILI9325_WR_Data_Index(0x20, X0); 
   ILI9325_WR_Data_Index(0x21, Y0);
	 ILI9325_WR_Index(0x22);
   for(i=0;i<W;i++)
	 {
		 ILI9325_WR_Data(Color);
	 }
}

void Draw_V_Line(unsigned int X0,unsigned int Y0,unsigned int H,unsigned int Color)
{
	 int i=0;
	 ILI9325_WR_Data_Index(0x50, X0); 
   ILI9325_WR_Data_Index(0x51,X0); 
   ILI9325_WR_Data_Index(0x52, Y0); 
   ILI9325_WR_Data_Index(0x53,Y0+H); 
   ILI9325_WR_Data_Index(0x20, X0); 
   ILI9325_WR_Data_Index(0x21, Y0);
	 ILI9325_WR_Index(0x22);
   for(i=0;i<H;i++)
	 {
		 ILI9325_WR_Data(Color);
	 }
}
void ILI9325_Show_Pic(unsigned int X0,unsigned int Y0,unsigned int With,unsigned int Height,const unsigned short int *Pic)
{
	 int i=0;
	 ILI9325_WR_Data_Index(0x50, X0); 
   ILI9325_WR_Data_Index(0x51,(X0+With)-1); 
   ILI9325_WR_Data_Index(0x52, Y0); 
   ILI9325_WR_Data_Index(0x53,(Y0+Height)-1); 
   ILI9325_WR_Data_Index(0x20, X0); 
   ILI9325_WR_Data_Index(0x21, Y0);
	 ILI9325_WR_Index(0x22);
   for(i=0;i<(With*Height);i++)
	 {
		 ILI9325_WR_Data(Pic[i]);
	 }
}
