#include <LPC17xx.h>

#define    ILI9325_Data_Dir_Out            LPC_GPIO1->FIODIRH=0xFFFF
#define    ILI9325_Control_Dir_Out         LPC_GPIO0->FIODIR0=0xFF
#define    ILI9325_Data_Port_Set           LPC_GPIO1->FIOSETH
#define    ILI9325_Data_Port_Clr           LPC_GPIO1->FIOCLRH
#define    ILI9325_Control_Port_Set		     LPC_GPIO0->FIOSET0
#define    ILI9325_Control_Port_Clr		     LPC_GPIO0->FIOCLR0

#define    RS_Pin						   0
#define    WR_Pin						   1
#define    RST_Pin						 2

#define    RS_L                        	   ILI9325_Control_Port_Clr=(1<<RS_Pin)
#define    RS_H                        	   ILI9325_Control_Port_Set=(1<<RS_Pin)
#define    WR_L                        	   ILI9325_Control_Port_Clr=(1<<WR_Pin)
#define    WR_H 						               ILI9325_Control_Port_Set=(1<<WR_Pin)
#define    RST_L                           ILI9325_Control_Port_Clr=(1<<RST_Pin)
#define    RST_H                           ILI9325_Control_Port_Set=(1<<RST_Pin)

void ILI9325_WR_Index(unsigned char Index);
void ILI9325_WR_Data (unsigned int Data);
void ILI9325_WR_Data_Index(unsigned char Index,unsigned int Data);
void ILI9325_Init(void);
void ILI9325_Clear(unsigned int Color); 
void ILI9325_Set_X_Y(unsigned int X,unsigned int Y);
void ILI9325_Set_Area(unsigned int X0,unsigned int Y0,unsigned int X1,unsigned int Y1);
void ILI9325_WR_Char(unsigned int X,unsigned int Y,char Data,unsigned int Back_Color,unsigned int Fore_Color);
void ILI9325_WR_String(unsigned int X,unsigned int Y,char *String,unsigned int Back_Color,unsigned int Fore_Color);
void ILI9325_WR_Char16_32(unsigned int X,unsigned int Y,char Data,unsigned int Back_Color,unsigned int Fore_Color);
void ILI9325_WR_String16_32(unsigned int X,unsigned int Y,char *String,unsigned int Back_Color,unsigned int Fore_Color);
void Draw_H_Line(unsigned int X0,unsigned int Y0,unsigned int W,unsigned int Color);
void Draw_V_Line(unsigned int X0,unsigned int Y0,unsigned int H,unsigned int Color);
void ILI9325_Show_Pic(unsigned int X0,unsigned int Y0,unsigned int With,unsigned int Height,const unsigned short int *Pic);
